<template>
<div>
  <v-container grid-list-xl v-if="!loading">
      <v-layout align-center justify-center row>
          <v-flex xl4>
              <img v-bind:src="movie.img" :width="200" :height="250"   alt="poster"/>        
          </v-flex>
          <v-flex xl12 v-if="movie != undefined">
              <h1 class="Title"> {{ movie.title }} </h1> 
        <ul>
            <li> {{ movie.synopsys }} </li>
            <li>{{ movie.year }}</li>
            <li> {{ movie.type }} </li>
            <li> 
                <ul v-if ="movie.realisator != undefined">Realisator : <br>
                    <li> {{ movie.realisator.firstname }} {{ movie.realisator.lastname }} </li>
                    <li> {{ movie.realisator.birthdate }} </li>
                    <li> {{ movie.realisator.nationality }} </li>
                </ul>
            </li>
        </ul>
        </v-flex>
      </v-layout>
        <v-layout align-center justify-space-around row >
            <v-flex>
                <v-select class="select" light="true" dark="false" v-model="selected" :options="[1,2,3,4,5]"></v-select>
            </v-flex>
            <v-flex>
                <button class="v-btn btn" v-on:click="voter">Voter</button> 
                <button class="v-btn btn" v-on:click="retour">Retour</button>
            </v-flex>

        </v-layout>

        <v-layout align-center justify-center column fill-height>
            <v-flex xl12> 
                <h3>Pourcentage des votes de ce film sur tous les votes : </h3> 
            </v-flex>
        </v-layout>
        <v-layout align-center justify-space-between row fill-height >
            <v-progress-circular class="v-progress-circular"  :rotate="360" :size="150" :width="15" :value="pourcentage[0]" color="#F78446"> Note 1 : <br>   {{ pourcentage[0] }}% </v-progress-circular>
            <v-progress-circular class="v-progress-circular"  :rotate="360" :size="150" :width="15" :value="pourcentage[1]" color="#F78446"> Note 2 : <br>   {{ pourcentage[1] }}%</v-progress-circular>
            <v-progress-circular class="v-progress-circular"  :rotate="360" :size="150" :width="15" :value="pourcentage[2]" color="#F78446"> Note 3 : <br>   {{ pourcentage[2] }}%</v-progress-circular>
            <v-progress-circular class="v-progress-circular"  :rotate="360" :size="150" :width="15" :value="pourcentage[3]" color="#F78446"> Note 4 : <br>   {{ pourcentage[3] }}%</v-progress-circular>
            <v-progress-circular class="v-progress-circular"  :rotate="360" :size="150" :width="15" :value="pourcentage[4]" color="#F78446"> Note 5 : <br>   {{ pourcentage[4] }}%</v-progress-circular>
        </v-layout>
  </v-container>
  </div>
</template>

<script>
import { db } from "../firebase";
export default{
    data(){
        return{
            selected:null,
            loading: true,
            movie:{},
            movies:[],
            pourcentage: []
        }
    },
    methods:{
        voter:function(){
            switch(this.selected){
                case 1:
                this.movie.note.n1 += 1;
                break;

                case 2:
                this.movie.note.n2 += 1;
                break;

                case 3:
                this.movie.note.n3 += 1;
                break;

                case 4:
                this.movie.note.n4 += 1;
                break;

                case 5:
                this.movie.note.n5 += 1;
                break;
            }
            this.getPourcentage();
            this.updateMovie();
        },

        retour:function(){
            return this.$router.push({name:'home'});
        },

        updateMovie: async function(){
            const ref = await db.collection('movies').doc(this.$route.params.movie);
            console.log(this.movie.note);
            ref.set(this.movie) 
        },
        getMovie: async function(){
            const ref = await db.collection('movies').doc(this.$route.params.movie);
            var result ;
            ref.get().then((doc)=>{
                if(doc.exists){
                    result = doc.data();
                    this.movie = result;
                }
                else{
                    alert("no document");
                }
            })
            this.loading = false;
        },
    
        getMovies: async function(){
            var result = [];
            const ref = await db.collection('movies').onSnapshot(function(snapchot){
                snapchot.forEach((doc)=>{
                    result.push({
                        id: doc.id,
                        title: doc.data().title,
                        year: doc.data().year,
                        note: doc.data().note,
                        realisator: doc.data().realisator,
                        synopsys: doc.data().synopsys,
                        display: doc.data().display,
                        img: doc.data().img
                    })
                })
            })
            this.movies = result
        },

        getPourcentage: async function(){
            const ref = await db.collection('movies').doc(this.$route.params.movie);
            ref.get().then((doc)=>{
                if(doc.exists){
                    var movieNotes = doc.data().note;
                    var result =[];
                    for(var i = 0;i<5;i++){
                        result.push(0);
                    }
                    var note = [];
                    var voteTT = movieNotes.n1+movieNotes.n2+movieNotes.n3+movieNotes.n4+movieNotes.n5;
                    note.push(movieNotes.n1);
                    note.push(movieNotes.n2);
                    note.push(movieNotes.n3);
                    note.push(movieNotes.n4);
                    note.push(movieNotes.n5);

                    if(voteTT != 0){
                    result[0]=(note[0]*100/voteTT).toFixed(3);
                    result[1]=(note[1]*100/voteTT).toFixed(3);
                    result[2]=(note[2]*100/voteTT).toFixed(3);
                    result[3]=(note[3]*100/voteTT).toFixed(3);
                    result[4]=(note[4]*100/voteTT).toFixed(3);
                    }
                    this.pourcentage = result;
                }
                else{
                    alert("no document");
                }
            })
        }
    },

    created:function(){
        this.getMovies();
        this.getMovie();
        this.getPourcentage();
    },

}
</script>
